/*
 * Copyright (c) 2012 - 2013 Alexandre Tuleu
 *
 * This file is part of biorob-cpp.
 *
 *   biorob-cpp is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as
 *   published by the Free Software Foundation, either version 3 of the
 *   License, or (at your option) any later version.
 *
 *   biorob-cpp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of both the GNU General Public
 *   License AND GNU Lesser General Public License along with
 *   biorob-cpp.  If not, see <http://www.gnu.org/licenses/>.
 */


/**
 * \file Command.cpp
 *
 *  \date Mar 27, 2012
 *  \author Alexandre Tuleu
 */

#include "Command.h"

namespace cli {
Command::Command(const std::string & name,
                 unsigned int nbArgs,
                 bool acceptOptionnalArgs)
	: d_name(name)
	, d_nbArgs(nbArgs)
	, d_acceptOptionnalArgs(acceptOptionnalArgs){
}



Command::~Command(){}



const std::string & Command::Name() const{
	return d_name;
}



unsigned int Command::NumberbOfArguments() const{
	return d_nbArgs;
}



bool Command::AcceptOptionnalArgs() const{
	return d_acceptOptionnalArgs;
}
}
