/*
 * Copyright (c) 2012 - 2013 Alexandre Tuleu
 *
 * This file is part of biorob-cpp.
 *
 *   biorob-cpp is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as
 *   published by the Free Software Foundation, either version 3 of the
 *   License, or (at your option) any later version.
 *
 *   biorob-cpp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of both the GNU General Public
 *   License AND GNU Lesser General Public License along with
 *   biorob-cpp.  If not, see <http://www.gnu.org/licenses/>.
 */


/*
 * Copyright (c) 2012  Alexandre Tuleu
 *
 * This file is part of biorob-cpp.
 *
 *   biorob-cpp is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as
 *   published by the Free Software Foundation, either version 3 of the
 *   License, or (at your option) any later version.
 *
 *   biorob-cpp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of both the GNU General Public
 *   License AND GNU Lesser General Public License along with
 *   PROJECT.  If not, see <http://www.gnu.org/licenses/>.
 */


/**
 * \file DisplayWidget.h
 *
 *  \date Oct 24, 2012
 *  \author Alexandre Tuleu
 */

#ifndef BIOROB_CLI_DISPLAYWIDGET_H_
#define BIOROB_CLI_DISPLAYWIDGET_H_

#include "Widget.h"
#include <ostream>
#include <streambuf>
#include <vector>
#include <tr1/memory>

namespace cli {
/**
 *
 */
class DisplayWidget : public Widget{
public:
	DisplayWidget(const Widget::Def & def);
	virtual ~DisplayWidget();

	std::ostream & Stream();
	std::ostream & ErrStream();
private :
	class StreamBuf : public std::streambuf{
		DISABLE_COPY(StreamBuf)
	public :
		StreamBuf(WINDOW * w, int colorPair = -1, std::size_t bufSize = 256);
		virtual ~StreamBuf();
	protected :
		int sync();
		int overflow(int c);
	private :
		void operator=(const StreamBuf &); //UNDEFINED
		bool flush();
		WINDOW * d_w;
		std::vector<char> d_buffer;
		const int d_colorPair;
	};

	std::tr1::shared_ptr<std::ostream> d_stream, d_errStream;

};
}
#endif // BIOROB_CLI_DISPLAYWIDGET_H_
