/*
 * Copyright (c) 2012 - 2013 Alexandre Tuleu
 *
 * This file is part of biorob-cpp.
 *
 *   biorob-cpp is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as
 *   published by the Free Software Foundation, either version 3 of the
 *   License, or (at your option) any later version.
 *
 *   biorob-cpp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of both the GNU General Public
 *   License AND GNU Lesser General Public License along with
 *   biorob-cpp.  If not, see <http://www.gnu.org/licenses/>.
 */


/*
 * Copyright (c) 2012  Alexandre Tuleu
 *
 * This file is part of biorob-cpp.
 *
 *   biorob-cpp is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as
 *   published by the Free Software Foundation, either version 3 of the
 *   License, or (at your option) any later version.
 *
 *   biorob-cpp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of both the GNU General Public
 *   License AND GNU Lesser General Public License along with
 *   PROJECT.  If not, see <http://www.gnu.org/licenses/>.
 */


/**
 * \file base/common.h
 *
 * \date Oct 19 2012
 * \author Alexandre Tuleu
 */

#ifndef BIOROB_CPP_BASE_COMMON_H_
#define BIOROB_CPP_BASE_COMMON_H_

#ifndef DISABLE_COPY
#define DISABLE_COPY(ClassName) private :\
	ClassName( const ClassName & src); /* UNIMPLEMENTED */
#endif

#ifndef DISABLE_ASSIGNEMENT
#define DISABLE_ASSIGNEMENT(ClassName) private :\
	void operator=(const ClassName & src); /* UNIMPLEMENTED */
#endif //DISABLE_ASSIGNEMENT

#ifdef __GNUG__
#define GXX_VERSION (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__ )
#else
#define GXX_VERSION (0)
#endif

#if defined(__clang__) || (defined(__GNUG__) && GXX_VERSION >= 40600)
#define BIOROB_CPP_USE_NEW_WARNINGS_PRAGMA
#elif defined(__GNUG__) && GXX_VERSION >= 40300
#define BIOROB_CPP_USE_GLOBAL_WARNINGS_PRAGMA
#endif

#if !defined(C_EXPORT) && !defined(C_EXPORT_START) && !defined(C_EXPORT_END)
#ifdef __cplusplus
#define C_EXPORT extern "C"
#define C_EXPORT_START extern "C"�{
#define C_EXPORT_END }
#else // __cplusplus
#define C_EXPORT
#define C_EXPORT_START
#define C_EXPORT_END
#endif //__cplusplus
#endif //!defined(C_EXPORT) && !defined(C_EXPORT_START) && !defined(C_EXPORT_END)

#endif //BIOROB_CPP_BASE_COMMON_H_
