/*
 * Copyright (c) 2012 - 2013 Alexandre Tuleu
 *
 * This file is part of biorob-cpp.
 *
 *   biorob-cpp is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as
 *   published by the Free Software Foundation, either version 3 of the
 *   License, or (at your option) any later version.
 *
 *   biorob-cpp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of both the GNU General Public
 *   License AND GNU Lesser General Public License along with
 *   biorob-cpp.  If not, see <http://www.gnu.org/licenses/>.
 */


/**
 * Env.h
 *
 *  Created on: Jan 4, 2013
 *      Author: tuleu
 */

#ifndef BIOROB_CPP_OS_ENV_H_
#define BIOROB_CPP_OS_ENV_H_

#include <string>

namespace os {

class Env {
public:
	static std::string Get(const std::string & name,
	                       bool throwExcept = true);

	static void Set(const std::string & name,
	                const std::string & value,
	                bool overwrite = true);

	static void Unset(const std::string & name);

	static bool IsSet(const std::string & name);
};

} /* namespace os */
#endif /* BIOROB_CPP_OS_ENV_H_ */
