/*
 * Copyright (c) 2012 - 2013 Alexandre Tuleu
 *
 * This file is part of biorob-cpp.
 *
 *   biorob-cpp is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as
 *   published by the Free Software Foundation, either version 3 of the
 *   License, or (at your option) any later version.
 *
 *   biorob-cpp is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of both the GNU General Public
 *   License AND GNU Lesser General Public License along with
 *   biorob-cpp.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef BIOROB_CPP_STATIC_TYPEMAP_H_
#define BIOROB_CPP_STATIC_TYPEMAP_H_

namespace biorobcpp
{
	class TypeMapBase{/* Dummy class, use default constructor and destructor */};
	typedef TypeMapBase * TypeID;
	/**
	 * Static TypeMap to a type.
	 */
	template <typename T>
	class TypeMap : public TypeMapBase {
	public :
		static TypeID ID();
	private :
		TypeMap();//UNDEFINED
		~TypeMap();//UNDEFINED
		static TypeID s_instance;
	};

	template <typename T>
	TypeID TypeMap<T>::s_instance(0);

	template <typename T>
	TypeID TypeMap<T>::ID(){
		if( ! s_instance ){
			s_instance = new TypeMapBase();
		}
		return s_instance;
	}
}



#endif  // BIOROB_CPP_STATIC_TYPEMAP_H_
